import CBMSBatSoh
import log
#coding=utf-8
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
from sqlalchemy import create_engine
import time, datetime
from LIB.MIDDLE.CellStateEstimation.Common import DBDownload

dbManager = DBManager.DBManager()
if __name__ == "__main__":
    excelpath=r'D:\Platform\platform_python\data_analyze_platform\USER\01qixiang\sn-20210903.xlsx'
    SNdata_6060 = pd.read_excel(excelpath, sheet_name='科易6060')
    SNdata_6040 = pd.read_excel(excelpath, sheet_name='科易6040')
    SNdata_4840 = pd.read_excel(excelpath, sheet_name='科易4840')
    SNdata_L7255 = pd.read_excel(excelpath, sheet_name='格林美-力信7255')
    SNdata_C7255 = pd.read_excel(excelpath, sheet_name='格林美-CATL7255')
    SNdata_U7255 = pd.read_excel(excelpath, sheet_name='优旦7255')
    SNnums_6060=SNdata_6060['SN号'].tolist()
    SNnums_6040=SNdata_6040['SN号'].tolist()
    SNnums_4840=SNdata_4840['SN号'].tolist()
    SNnums_L7255=SNdata_L7255['SN号'].tolist()
    SNnums_C7255=SNdata_C7255['SN号'].tolist()
    SNnums_U7255=SNdata_U7255['SN号'].tolist()
    SNnums= SNnums_6060 + SNnums_L7255 + SNnums_C7255 + SNnums_6040 + SNnums_4840 + SNnums_U7255

    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=30)
    end_time=str(now_time)
    start_time=str(start_time)

    #log信息配置
    mylog=log.Mylog('log.txt','error')
    mylog.logcfg()

    for sn in SNnums:
        try:
            if 'PK500' in sn:
                celltype=1 #6040三元电芯
            elif 'PK502' in sn:
                celltype=2 #4840三元电芯
            elif 'PK504' in sn:
                celltype=99    #60ah林磷酸铁锂电芯
            elif 'MGMLXN750' in sn:
                celltype=3 #力信50ah三元电芯
            elif 'MGMCLN750' in sn: 
                celltype=4 #CATL 50ah三元电芯
            else:
                print('未找到对应电池编号！！！\n',sn)
                # sys.exit()
            
            sn='PK504B10100004353'
            celltype=99
            start_time='2021-04-01 19:12:26'
            end_time='2021-06-02 19:12:26'
            # df_bms= pd.read_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\01qixiang\98Download\\'+'BMS_'+sn+'.csv',encoding='GB18030')
            # df_accum= pd.read_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\01qixiang\98Download\\'+'BMS_accum_'+sn+'.csv',encoding='GB18030')
            
            #..........................................................................读取原始数据库数据...........................................................................
            dbManager = DBManager.DBManager()
            df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms','accum'])
            df_bms = df_data['bms']
            df_accum=df_data['accum']
            # df_bms.to_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\01qixiang\98Download\\'+'BMS_'+sn+'.csv',encoding='GB18030')
            # df_accum.to_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\01qixiang\98Download\\'+'BMS_accum_'+sn+'.csv',encoding='GB18030')

            #..........................................................................读取结果数据库数据.........................................................................
            host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
            port=3306
            db='qx_cas'
            user='qx_read'
            password='Qx@123456'
            tablename='cellstateestimation_soh'
            DBRead=DBDownload.DBDownload(host, port, db, user, password)
            with DBRead as DBRead:
                df_soh=DBRead.getdata('time_st','time_sp','sn','method','soh','cellsoh', tablename=tablename, sn=sn)

            #..............................................................................计算soh...................................................................................
            BatSoh=CBMSBatSoh.BatSoh(sn,celltype,df_bms,df_accum,df_soh)
            df_res=BatSoh.batsoh()
            df_res.to_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\01qixiang\99Result\\'+'CBMS_SOH'+sn+'_1.csv',encoding='GB18030')
            # print('done！！！')
             
        except IndexError as e:
            print(repr(e))
            mylog.logopt(sn,e)
            pass
